package main

import (
	"log"
	"os"

	"github.com/CGSG-2021-AE4/modem-test/api/modem"
)

func main() {
	log.Println("CGSG forever!!!")
	if err := mainE(); err != nil {
		log.Println("MAIN finished with error:", err.Error())
	}
	log.Println("END")
}

func mainE() error {
	logger := log.New(os.Stdout, "main:", log.LstdFlags)
	m := modem.New(log.New(logger.Writer(), "modem:", log.LstdFlags))
	logger.Println("||||||||||||||||| INIT |||||||||||||||")
	if err := m.Init(); err != nil {
		return err
	}
	if !m.Validate() {
		logger.Println("AAAAAAAAAAAAAAA Validation failed")
		return nil
	}
	logger.Println("||||||||||||||||| GET INFO |||||||||||||||||")
	logger.Println(m.GetData())

	// logger.Println("||||||||||||||||| SEND SMS |||||||||||||||||")
	// logger.Println(m.At().Send("AT+CNUM"))
	// if err := m.Sms().Send("+79218937173", "CGSG forever"); err != nil {
	// 	return err
	// }
	// if ms, err := m.Sms().ReadNew(); err != nil {
	// return err
	// } else {
	// logger.Println("NEW:", ms)
	// }
	logger.Println("||||||||||||||||| Checking gps status  |||||||||||||||||")
	st, err := m.Gps().CheckStatus()
	if err != nil {
		return err
	}
	logger.Println("GPS Status:\n", st)

	return nil
}
